<p align="center">
  <a href="https://marblejs.com">
    <img src="https://github.com/marblejs/marble/blob/master/assets/img/logo.png?raw=true" width="320" alt="Marble.js logo"/>
  </a>
</p>

<p align="center">
  <a href="https://www.npmjs.com/package/@marblejs/core">
    <img src="https://github.com/marblejs/marble/workflows/Test%20suite/badge.svg" alt="GitHub Actions" status" height="18">
  </a>
  <a href="https://badge.fury.io/js/%40marblejs%2Fcore">
    <img src="https://badge.fury.io/js/%40marblejs%2Fcore.svg" alt="npm version" height="18">
  </a>
  <a href="https://codecov.io/gh/marblejs/marble?branch=master">
    <img src="https://codecov.io/gh/marblejs/marble/coverage.svg?branch=master" alt="Codecov coverage" height="18">
  </a>
  <a href="https://lernajs.io">
    <img src="https://img.shields.io/badge/maintained%20with-lerna-cc00ff.svg" alt="Maintained with lerna" height="18">
  </a>
  <a href="https://gitter.im/marblejs/community?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge">
    <img src="https://badges.gitter.im/marblejs/community.svg" alt="Gitter" height="18">
  </a>
</p>

<p align="center">
Functional reactive <a href="http://nodejs.org" target="blank">Node.js</a> framework for building <strong>server-side</strong> applications, based on <a href="https://www.typescriptlang.org" target="blank">TypeScript</a> and <a href="http://reactivex.io/rxjs" target="blank">RxJS</a>.
</p>

## <a name="ecosystem"></a> Ecosystem
| Name                        | Description                                                                                  |
| --------------------------- | -------------------------------------------------------------------------------------------- |
| [@marblejs/core](https://www.npmjs.com/package/@marblejs/core)                           | Framework core module           |
| [@marblejs/websockets](https://www.npmjs.com/package/@marblejs/websockets)               | WebSockets module               |
| [@marblejs/messaging](https://www.npmjs.com/package/@marblejs/messaging)                 | Messaging module                |
| [@marblejs/testing](https://www.npmjs.com/package/@marblejs/testing)                     | Testing module                  |
| [@marblejs/middleware-logger](https://www.npmjs.com/package/@marblejs/middleware-logger) | Logger middleware               |
| [@marblejs/middleware-body](https://www.npmjs.com/package/@marblejs/middleware-body)     | Body parser middleware          |
| [@marblejs/middleware-io](https://www.npmjs.com/package/@marblejs/middleware-io)         | I/O validation middleware       |
| [@marblejs/middleware-jwt](https://www.npmjs.com/package/@marblejs/middleware-jwt)       | JWT authorization middleware    |
| [@marblejs/middleware-joi](https://www.npmjs.com/package/@marblejs/middleware-joi)       | JOI-based validation middleware |
| [@marblejs/middleware-cors](https://www.npmjs.com/package/@marblejs/middleware-cors)     | CORS middleware                 |
| [@marblejs/middleware-multipart](https://www.npmjs.com/package/@marblejs/middleware-multipart) | Multipart middleware      |

## <a name="docs"></a> Documentation

For the latest updates, documentation, change log, and release information visit [docs.marblejs.com](https://docs.marblejs.com) and follow [@marble_js](https://twitter.com/marble_js) on Twitter.

## <a name="examples"></a> Examples

To view the example project, visit the [example](https://github.com/marblejs/example) repository.

## Authors

<table border="0">
  <tr>
    <td>
      <a href="https://github.com/JozefFlakus" style="color: white">
        <img src="https://github.com/JozefFlakus.png?s=150" width="150"/>
      </a>
    </td>
    <td>
      <p><strong>Józef Flakus</strong></p>
      <p><strong>contact: </strong><a href="mailto:hello@jflakus.com">hello@jflakus.com</a></p>
      <p><strong>twitter: </strong><a href="https://twitter.com/jozflakus">@jozflakus</a></p>
    </td>
  </tr>
</table>

## Contributors

<table>
  <tr>
    <td align="center">
      <a href="https://github.com/sebastianmusial" style="color: white">
        <img src="https://github.com/sebastianmusial.png?s=150" width="100"/>
        <p style="text-align: center"><small>Sebastian Musial</small></p>
      </a>
    </td>
    <td align="center">
      <a href="https://github.com/pdomaleczny" style="color: white">
        <img src="https://github.com/pdomaleczny.png?s=150" width="100"/>
        <p style="text-align: center"><small>Patryk Domałeczny</small></p>
      </a>
    </td>
    <td align="center">
      <a href="https://github.com/luciorubeens" style="color: white">
        <img src="https://github.com/luciorubeens.png?s=150" width="100"/>
        <p style="text-align: center"><small>Lúcio Rubens</small></p>
      </a>
    </td>
    <td align="center">
      <a href="https://github.com/krzysztof-miemiec" style="color: white">
        <img src="https://github.com/krzysztof-miemiec.png?s=150" width="100"/>
        <p style="text-align: center"><small>Krzysztof Miemiec</small></p>
      </a>
    </td>
    <td align="center">
      <a href="https://github.com/edbzn" style="color: white">
        <img src="https://github.com/edbzn.png?s=150" width="100"/>
        <p style="text-align: center"><small>Edouard Bozon</small></p>
      </a>
    </td>
  </tr>
</table>

## License

marble.js is MIT licensed
